"""Extend Resource Version and add json column for workflow version

Revision ID: a2194d0723b8
Revises: 1bde8ed4ca83
Create Date: 2024-02-20 17:09:50.263644

"""

import sqlalchemy as sa
from alembic import op
from sqlalchemy.dialects import mysql

# revision identifiers, used by Alembic.
revision = "a2194d0723b8"
down_revision = "1bde8ed4ca83"
branch_labels = None
depends_on = None


def upgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.add_column("resource_version", sa.Column("synchronization_request_uid", sa.BINARY(length=16), nullable=True))
    op.add_column(
        "resource_version", sa.Column("synchronization_request_description", sa.String(length=512), nullable=True)
    )
    op.add_column("resource_version", sa.Column("last_used_timestamp", sa.Integer(), nullable=True))
    op.add_column(
        "resource_version", sa.Column("times_used", sa.Integer(), server_default=sa.text("0"), nullable=False)
    )
    op.create_foreign_key(
        None, "resource_version", "user", ["synchronization_request_uid"], ["uid"], ondelete="SET NULL"
    )
    op.add_column("resource", sa.Column("private", sa.Boolean(), server_default=sa.text("1"), nullable=False))
    op.add_column("workflow_version", sa.Column("parameter_extension", sa.JSON(), nullable=True))

    op.alter_column(
        "resource_version",
        "status",
        existing_type=mysql.ENUM(
            "RESOURCE_REQUESTED",
            "SYNC_REQUESTED",
            "DENIED",
            "SYNCHRONIZING",
            "SYNC_ERROR",
            "SYNCHRONIZED",
            "SETTING_LATEST",
            "LATEST",
            "CLUSTER_DELETING",
            "CLUSTER_DELETE_ERROR",
            "CLUSTER_DELETED",
            "S3_DELETING",
            "S3_DELETE_ERROR",
            "S3_DELETED",
        ),
        type_=mysql.ENUM(
            "RESOURCE_REQUESTED",
            "WAIT_FOR_REVIEW",
            "DENIED",
            "APPROVED",
            "SYNC_REQUESTED",
            "SYNCHRONIZING",
            "SYNC_ERROR",
            "SYNCHRONIZED",
            "SETTING_LATEST",
            "LATEST",
            "CLUSTER_DELETING",
            "CLUSTER_DELETE_ERROR",
            "S3_DELETING",
            "S3_DELETE_ERROR",
            "S3_DELETED",
        ),
        existing_nullable=False,
    )
    # ### end Alembic commands ###


def downgrade():
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_column("workflow_version", "parameter_extension")
    op.drop_constraint("resource_version_ibfk_3", "resource_version", type_="foreignkey")
    op.drop_column("resource_version", "times_used")
    op.drop_column("resource_version", "last_used_timestamp")
    op.drop_column("resource_version", "synchronization_request_description")
    op.drop_column("resource_version", "synchronization_request_uid")
    op.drop_column("resource", "private")

    op.alter_column(
        "resource_version",
        "status",
        existing_type=mysql.ENUM(
            "RESOURCE_REQUESTED",
            "WAIT_FOR_REVIEW",
            "DENIED",
            "APPROVED",
            "SYNC_REQUESTED",
            "SYNCHRONIZING",
            "SYNC_ERROR",
            "SYNCHRONIZED",
            "SETTING_LATEST",
            "LATEST",
            "CLUSTER_DELETING",
            "CLUSTER_DELETE_ERROR",
            "S3_DELETING",
            "S3_DELETE_ERROR",
            "S3_DELETED",
        ),
        type_=mysql.ENUM(
            "RESOURCE_REQUESTED",
            "SYNC_REQUESTED",
            "DENIED",
            "SYNCHRONIZING",
            "SYNC_ERROR",
            "SYNCHRONIZED",
            "SETTING_LATEST",
            "LATEST",
            "CLUSTER_DELETING",
            "CLUSTER_DELETE_ERROR",
            "CLUSTER_DELETED",
            "S3_DELETING",
            "S3_DELETE_ERROR",
            "S3_DELETED",
        ),
        existing_nullable=False,
    )
    # ### end Alembic commands ###
